/*
 * DANG_BEGIN_MODULE
 *
 *
 *
 * DANG_END_MODULE
 *
 * DANG_BEGIN_CHANGELOG
 *
 * $Date: $
 * $Source: $
 * $Revision: $
 * $State: $
 *
 * $Log: $
 *
 * DANG_END_CHANGELOG
 */

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if_ether.h>
#include <signal.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <time.h>
#include <string.h>

#include "dosemu.h"
#include "emu_mem.h"
#include "emu_termio.h"
#include "keyb.h"
#include "emu_mouse.h"
#include "emu_int.h"
#include "emu_pic.h"
#include "emu_bitops.h"

#ifdef CONFIG_SIG
extern SillyG_t *SillyG;

inline void
process_interrupt(SillyG_t *sg)
{
  int irq;

  if ((irq = sg->irq) != 0) {
    h_printf("INTERRUPT: 0x%02x\n", irq);
    pic_request(irq);
  }
}
#endif

void
io_select(fd_set fds)
{
  static int selrtn;
  static struct timeval tvptr;

  tvptr.tv_sec=0L;
  tvptr.tv_usec=0L;

#if defined(CONFIG_SIG) && defined(CONFIG_EMUMODULE)
  if (SillyG) {
    if (get_irq_bits()) {
      SillyG_t *sg=SillyG;
      while (sg->fd) {
        if (get_and_reset_irq(sg->irq)) {
          h_printf("SIG: We have an interrupt\n");
          process_interrupt(sg);
        }
        sg++;
      }
    }
  }
#endif
  while ( ((selrtn = select(25, &fds, NULL, NULL, &tvptr)) == -1)
        && (errno == EINTR)) {
    tvptr.tv_sec=0L;
    tvptr.tv_usec=0L;
    g_printf("WARNING: interrupted io_select: %s\n", strerror(errno));
  }

  switch (selrtn) {
    case 0:			/* none ready, nothing to do :-) */
      return;
      break;

    case -1:			/* error (not EINTR) */
      error("ERROR: bad io_select: %s\n", strerror(errno));
      break;

    default:			/* has at least 1 descriptor ready */

#ifdef CONFIG_SIG
#ifndef CONFIG_EMUMODULE
      if (SillyG) {
        SillyG_t *sg=SillyG;
        while (sg->fd) {
	  if (FD_ISSET(sg->fd, &fds)) {
	    h_printf("SIG: We have an interrupt\n");
	    process_interrupt(sg);
	  }
	  sg++;
	}
      }
#endif
#endif
      if (mice->intdrv || mice->type == MOUSE_PS2)
	if (FD_ISSET(mice->fd, &fds)) {
		m_printf("MOUSE: We have data\n");
	  pic_request(PIC_IRQ12);
	}
      if (FD_ISSET(kbd_fd, &fds)) {
	getKeys();
      }

      /* XXX */
#if 0
      fflush(stdout);
#endif
      break;
    }
#if 0
#ifdef CONFIG_IPX
    pic_request(16);
#endif
#endif

}
